package org.groundwork.foundation.mq;

import java.io.PrintStream;
import java.io.ByteArrayInputStream;
import java.util.Hashtable;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.groundwork.foundation.mq.*;

// Referenced classes of package org.groundwork.foundation.mq:
//            nscafe, nscafeConfig

public class nscafeXML
{
    public nscafeXML()
    {
    }

    public static Hashtable getAttributes(nscafeServer nscafeInstance, String xmlRequest)
    {
        Hashtable attributes = new Hashtable();
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = null;
        Document doc = null;
        
        try
        {
            db = dbf.newDocumentBuilder();
        }
        catch(ParserConfigurationException pe)
        {
            if(nscafeInstance.config.debugLevel)
                System.out.println("nscafe: Error parsing XML payload: " + pe);
            return null;
        }
        if(db == null)
            return null;
        try
        {
            ByteArrayInputStream is = new ByteArrayInputStream(xmlRequest.getBytes());
            doc = db.parse(is);
        }
        catch(Exception e)
        {
            if(nscafeInstance.config.debugLevel)
                System.out.println("nscafe: Error streaming XML payload: " + e);
            return null;
        }
        
        if(doc == null)
            return null;
        
        NamedNodeMap insertAttributes = doc.getDocumentElement().getAttributes();
        int len = insertAttributes.getLength();
        String name = "";
        String value = "";
        for(int attCount = 0; attCount < len; attCount++)
        {
            Node attribute = insertAttributes.item(attCount);
            name = attribute.getNodeName();
            value = attribute.getNodeValue();
            if(name != null && value != null && name.length() > 0)
                attributes.put(name, value);
        }

        if(attributes.isEmpty())
        {
            if(nscafeInstance.config.debugLevel)
                System.out.println("Error parsing XML payload: attributes are empty.");
            return null;
        } else
        {
            return attributes;
        }
    }

    public static String getAttribute(Hashtable attribs, String name)
    {
        String attrib = (String)attribs.get(name);
        if(attrib == null || attrib.trim().length() == 0)
            return "-";
        else
            return attrib;
    }
}
